package tumblr.Android;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.HashMap;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;



public class ReadDashboard {
	
	private int posts_start, posts_total;
	private boolean posts_type;
	private ArrayList<PostRead> posts;
	private HashMap<String,String> tumblelog;
	
	public void readData(String nome) throws Exception {
	    try {
	        // Cria URL e OutputStream
	    	URL url = new URL("http://"+ nome +".tumblr.com/api/read/json");
	        URLConnection conn = url.openConnection();
	        conn.setDoOutput(true);
	        OutputStreamWriter writer = new OutputStreamWriter(conn.getOutputStream());
	           
	        // Resposta
	        StringBuffer answer = new StringBuffer();
	        BufferedReader reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
	        String line;
	        while ((line = reader.readLine()) != null) {
	            answer.append(line);
	        }
	        writer.close();
	        reader.close();
	        
	        //Organizar output JSON
	        String ans = answer.toString();
	        int ind = ans.indexOf("=");
	        ans = ans.substring(ind+2,ans.length()-1);
	        // System.out.println("aqui1");
	        JSONObject tumblr_api_read = new JSONObject(ans); 
	        
	        JSONObject tumblelog_str = tumblr_api_read.getJSONObject("tumblelog"); 
	        tumblelog = getTumbleLog(tumblelog_str);
	        
	        posts_start = tumblr_api_read.getInt("posts-start"); 
	        posts_total = tumblr_api_read.getInt("posts-total"); 
	        posts_type = tumblr_api_read.getBoolean("posts-type");        
	        // System.out.println("aqui2");
	        JSONArray posts_arr = tumblr_api_read.getJSONArray("posts"); 
	        
	        for(int k = 0; k < posts_arr.length(); k++)
	        	// System.out.println((JSONObject) posts_arr.get(k));
	        posts = new ArrayList<PostRead>();
	        for(int i = 0; i < posts_arr.length(); i++)
	        {
	        	 System.out.println((JSONObject) posts_arr.get(i));
	        	JSONObject post= ((JSONObject) posts_arr.get(i));
	        	String type = post.getString("type"); 	   
	        	// System.out.println("aquia");
	        	String id="";
	        	if(!type.equals("photo"))
	        		id = post.getString("id");
	        	else
	        	{
	        		Object lu  = post.get("id");
	        	    id = lu.toString();//// System.out.println("a = " + lu);
	        	}
	        	// System.out.println("aquib");
        		String url_post = post.getString("url"); 
        		// System.out.println("aquic");
        		String url_slug_post = post.getString("url-with-slug");
        		// System.out.println("aquid");
        		String date_gmt = post.getString("date-gmt");
        		// System.out.println("aquie");
        		String date = post.getString("date");
        		// System.out.println("aquif");
        		int bookmarklet = post.getInt("bookmarklet");
        		// System.out.println("aquig");
        		int mobile = post.getInt("mobile");
        		// System.out.println("aquih");
        		String feed_item = post.getString("feed-item");
        		// System.out.println("aquii");
        		int from_feed_id = post.getInt("from-feed-id");
        		// System.out.println("aquij");
        		int unix_timestamp = post.getInt("unix-timestamp");
        		// System.out.println("aquik");
        		String format = post.getString("format");
        		// System.out.println("aquil");
        		String reblog_key = post.getString("reblog-key");
        		// System.out.println("aquim");
        		String slug = post.getString("slug");
        		// System.out.println("aquin");
	        	if(type.equals("regular"))
	        	{	        		
	        		String regular_title = post.getString("regular-title");
	        		String regular_body = post.getString("regular-body");        		
	        		
	        		RegularPostRead rp = new RegularPostRead(type,id, url_post, url_slug_post, date_gmt, date, feed_item, 
	        			format, reblog_key, slug, regular_title, regular_body, bookmarklet, mobile, from_feed_id, unix_timestamp);
	        		posts.add(rp);
	        	}
	        	else if(type.equals("quote"))
	        	{
	        		String quote_text = post.getString("quote-text");
	        		String quote_source = post.getString("quote-source");        		
	        		
	        		QuotePostRead rp = new QuotePostRead(type,id, url_post, url_slug_post, date_gmt, date, feed_item, 
	        			format, reblog_key, slug, quote_text, quote_source, bookmarklet, mobile, from_feed_id, unix_timestamp);
	        		posts.add(rp);
	        	}
	        	else if(type.equals("photo"))
	        	{
	        		String photo_caption = post.getString("photo-caption");
	        		String photo_url_1280 = post.getString("photo-url-1280");
	        		String photo_url_500 = post.getString("photo-url-500");
	        		String photo_url_400 = post.getString("photo-url-400");
	        		String photo_url_250 = post.getString("photo-url-250");
	        		String photo_url_100 = post.getString("photo-url-100");
	        		String photo_url_75 = post.getString("photo-url-75");
	        		int width = post.getInt("unix-timestamp");
	        		int height = post.getInt("unix-timestamp");
	        		
	        		PhotoPostRead pp = new PhotoPostRead(type,id, url_post, url_slug_post, date_gmt, date, feed_item, format, reblog_key, slug, photo_caption, 
	        				photo_url_1280, photo_url_500, photo_url_400, photo_url_250, photo_url_100, photo_url_75,
	        				bookmarklet, mobile, from_feed_id, unix_timestamp, width, height);
	        		posts.add(pp);	        		
	        	}	        	
	        	else if(type.equals("video"))
	        	{
	        		
	        		String video_player_500 = post.getString("video-player-500");
	        		String video_source = post.getString("video-source");
	        		String video_player_250 = post.getString("video-player-250");
	        		String video_player = post.getString("video-player");
	        		String video_caption = post.getString("video-caption");
	        		
	        		VideoPostRead vp = new VideoPostRead(type,id, url_post, url_slug_post, date_gmt, date, feed_item, 
		        			format, reblog_key, slug, video_caption, video_source, video_player, video_player_500, video_player_250, bookmarklet, mobile, from_feed_id, unix_timestamp);
	        		
	        		posts.add(vp);
	        	}
	        	else if(type.equals("link"))
	        	{
	        		String link_text = post.getString("link-text");
	        		String link_url = post.getString("link-url");
	        		String link_description = post.getString("link-description");
	        		
	        		LinkPostRead rp = new LinkPostRead(type,id, url_post, url_slug_post, date_gmt, date, feed_item, 
	        			format, reblog_key, slug, link_text, link_url, link_description, bookmarklet, mobile, from_feed_id, unix_timestamp);
	        		posts.add(rp);
	        	}
	        	else if(type.equals("conversation"))
	        	{
	        		String conversation_title = post.getString("conversation-title");
	        		String conversation_text = post.getString("conversation-text");
	        		
	        		JSONArray conversations_arr = post.getJSONArray("conversation"); 
	        		ArrayList<Conversation> conversation = getConversations(conversations_arr);
	        		
	        		ConversationPostRead rp = new ConversationPostRead(type,id, url_post, url_slug_post, date_gmt, date, feed_item, 
	        			format, reblog_key, slug, conversation_title, conversation_text, conversation, bookmarklet, mobile, from_feed_id, unix_timestamp);
	        		posts.add(rp);
	        	}
	        	else if(type.equals("audio"))
	        	{	        		
	        		String id3artist = post.getString("id3-artist");
	        		String id3title = post.getString("id3-title");
	        		String id3track = post.getString("id3-track");
	        		String id3year = post.getString("id3-year");
	        		int audioplays = post.getInt("audio-plays");
	        		String audioplayer = post.getString("audio-player");
	        		String audiocaption = post.getString("audio-caption");
	        		String id3album = post.getString("id3-album");
	        		
	        		AudioPostRead rp = new AudioPostRead(type,id, url_post, url_slug_post, date_gmt, date, feed_item, 
	        			format, reblog_key, slug,audiocaption,id3artist, id3title, id3track, id3year,
	        			audioplays, audioplayer, id3album, bookmarklet, mobile, from_feed_id, unix_timestamp);
	        		posts.add(rp);
	        	}
	        }
	        
	        // System.out.println("Guardei todas as informaes lidas!");
	        
	        for(int a = 0; a < posts.size(); a++)
	        	System.out.println((a+1)+" ->"+posts.get(a).getUrl_post());
	        	        
	    } catch (MalformedURLException ex) {
	        ex.printStackTrace();
	    } catch (IOException ex) {
	        ex.printStackTrace();
	    }
	}

	private ArrayList<Conversation> getConversations(JSONArray conversationsArr) throws JSONException {
		
		ArrayList<Conversation> conversations = new ArrayList<Conversation>();
		for(int i=0; i < conversationsArr.length(); i++)
		{
			JSONObject obj = (JSONObject) conversationsArr.get(i);
			String name = obj.getString("name");
			String label = obj.getString("label");
			String phrase = obj.getString("phrase");
			
			Conversation cv = new Conversation(name,label,phrase);
			conversations.add(cv);
		}
		
		return conversations;
	}

	private HashMap<String, String> getTumbleLog(JSONObject tumblelogStr) throws JSONException {
		HashMap<String,String> tmp = new HashMap<String,String>();
		
		String name = tumblelogStr.getString("name"); 
		tmp.put("name", name);	
		
		String title = tumblelogStr.getString("title"); 
		tmp.put("title", title);
		
		String description = tumblelogStr.getString("description"); 
		tmp.put("description", description);
		
		String timezone = tumblelogStr.getString("timezone"); 
		tmp.put("timezone", timezone);
		
		Boolean cname = tumblelogStr.getBoolean("cname"); 
		tmp.put("cname", cname.toString());
		
		return tmp;
	}
	
	public int getPosts_start() {
		return posts_start;
	}

	public int getPosts_total() {
		return posts_total;
	}

	public boolean isPosts_type() {
		return posts_type;
	}

	public ArrayList<PostRead> getPosts() {
		return posts;
	}

	public HashMap<String, String> getTumblelog() {
		return tumblelog;
	}


}
