package tumblr.Android;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.MediaController;
import android.widget.TextView;
import android.widget.VideoView;

public class ShowDashBoard extends Activity{
	
	public static String nome=null;
	String inputUrl;
	ArrayList<PostRead> posts;	
	String urlLinkShow=null;
	
	public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
        initialize();
	}
	
	private void initialize()
	{
        nome = this.getIntent().getExtras().getString("nome");
        setContentView(R.layout.dashboard);
		ReadDashboard rd = new ReadDashboard();
	    try {
			rd.readData(nome);
			} catch (Exception e) {
				e.printStackTrace();
		}
		
		posts = rd.getPosts();	
		ArrayList<String> array =  new ArrayList<String>();
		
		for(int i=0; i < posts.size(); i++)
	    {
		
			String type = posts.get(i).getType();
			if(type.equals("regular")) 
			{
				array.add("Type: " +  type + "\n" + posts.get(i).getDate() + "\nTitulo: " + clean(((RegularPostRead)posts.get(i)).getRegular_title()));	 
			}
			else if(type.equals("quote"))
			{
				array.add("Type: " +  type + "\n" + posts.get(i).getDate() + "\nTitulo: " + clean(((QuotePostRead)posts.get(i)).getQuote_source()));	 
			}
			else if(type.equals("conversation"))
			{
				array.add("Type: " +  type + "\n" +  posts.get(i).getDate() + "\nTitulo: " + clean(((ConversationPostRead)posts.get(i)).getConversation_title()));	 
			}
			else if(type.equals("link"))
			{
				array.add("Type: " +  type + "\n" + posts.get(i).getDate() + "\nTitulo: " + clean(((LinkPostRead)posts.get(i)).getLink_text()));	 
			}
			else if(type.equals("photo"))
			{
				String s = ((PhotoPostRead)posts.get(i)).getPhoto_caption();
				
				s=clean(s);
				if(s.length() > 30)
					s = s.substring(0,29) + "...";				
				array.add("Type: " +  type + "\n" + posts.get(i).getDate() + "\nDescription: " + s);
			}
			else if(type.equals("audio"))
			{
				String s1 = ((AudioPostRead)posts.get(i)).getId3artist();
				String s2 = ((AudioPostRead)posts.get(i)).getId3album();
				String s3 = ((AudioPostRead)posts.get(i)).getId3title();
				String s = s1 + " - " + s2 + " - " + s3;
				array.add("Type: " +  type + "\n" + posts.get(i).getDate() + "\nInformation: " + s);
			}
			else
			{
				array.add("Type: " +  type + "\n" + posts.get(i).getDate());
			}
	    }
		
		String [] arr = (String[]) array.toArray(new String[array.size()]);
	
		
		ListView lv = (ListView)findViewById(R.id.listViewDashBoard);		
		
		lv.setAdapter(new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1,arr));
		
		lv.setOnItemClickListener(clickFile);
	}
	
	private String clean(String s)
	{
		while(s.indexOf("<p>")!=-1)
		{
			s=s.replace("<p>", "");
		}
		while(s.indexOf("</p>")!=-1)
		{
			s=s.replace("</p>", "");
		}
		while(s.indexOf("<ul>")!=-1)
		{
			s=s.replace("<ul>", "");
		}
		while(s.indexOf("</ul>")!=-1)
		{
			s=s.replace("</ul>", "");
		}
		while(s.indexOf("<li>")!=-1)
		{
			s=s.replace("<li>", "");
		}
		while(s.indexOf("</li>")!=-1)
		{
			s=s.replace("</li>", "");
		}
		while(s.indexOf("<em>")!=-1)
		{
			s=s.replace("<em>", "");
		}
		while(s.indexOf("</em>")!=-1)
		{
			s=s.replace("</em>", "");
		}
		while(s.indexOf("<ol>")!=-1)
		{
			s=s.replace("<ol>", "");
		}
		while(s.indexOf("</ol>")!=-1)
		{
			s=s.replace("</ol>", "");
		}
		while(s.indexOf("<strong>")!=-1)
		{
			s=s.replace("<strong>", "");
		}
		while(s.indexOf("</strong>")!=-1)
		{
			s=s.replace("</strong>", "");
		}
		return s;
	}

	private OnItemClickListener clickFile = new OnItemClickListener()
	{
		public void onItemClick(AdapterView<?> parent, View view, int position,
				long id) {
			viewPost(view, posts.get(position));
		}
	};
	
	public void viewPost(View v, PostRead post)
	{
		if(post.getType().equals("photo"))
	    {
			setContentView(R.layout.viewimagepost);
	    	TextView tv1 = (TextView)findViewById(R.id.PhotoViewDate);
		    tv1.setText(clean(((PhotoPostRead)post).getDate()));		    
		    
		    TextView tv2 = (TextView)findViewById(R.id.PhotoViewDesc);
		    if(!((((PhotoPostRead)post)).getPhoto_caption().isEmpty()))
		    	tv2.setText(clean((((PhotoPostRead)post)).getPhoto_caption()));
		    else
		    	tv2.setText("Body not found!");
			
			inputUrl = ((PhotoPostRead)post).getPhoto_url_250();
			Context context = v.getContext();
			Drawable image = ImageOperations(context,inputUrl,"image.jpg");
			ImageView imgView = (ImageView) findViewById(R.id.imageViewPost1);
			imgView.setImageDrawable(image);
			
			Button btn4 = (Button)findViewById(R.id.cancelarImagePostRead);
		    btn4.setOnClickListener(cancel);
			
	   }
	   else if(post.getType().equals("regular"))
	    {
		    setContentView(R.layout.postread);
		    
	    	TextView tv1 = (TextView)findViewById(R.id.RegularTextView01);
	    	tv1.setText(((RegularPostRead)post).getDate());
		    
		    TextView tv2 = (TextView)findViewById(R.id.RegularTextView02);
		    if(!(((RegularPostRead)post)).getRegular_title().isEmpty())
		    	tv2.setText(clean((((RegularPostRead)post)).getRegular_title()));
		    else
		    	tv2.setText("Title not found!");
		    
		    TextView tv3 = (TextView)findViewById(R.id.RegularTextView03);
		    if(!((((RegularPostRead)post)).getRegular_body().isEmpty()))
		    	tv3.setText(clean((((RegularPostRead)post)).getRegular_body()));
		    else
		    	tv3.setText("Body not found!");
		    Button btn4 = (Button)findViewById(R.id.cancelarTextPostRead);
		    btn4.setOnClickListener(cancel);
	    }
	    else if(post.getType().equals("conversation"))
	    {
	    	setContentView(R.layout.postread);
	    	TextView tv1 = (TextView)findViewById(R.id.RegularTextView01);
		    tv1.setText(((ConversationPostRead)post).getDate());
		    
		    TextView tv2 = (TextView)findViewById(R.id.RegularTextView02);
		    if(!(((ConversationPostRead)post)).getConversation_title().isEmpty())
		    	tv2.setText(clean((((ConversationPostRead)post)).getConversation_title()));
		    else
		    	tv2.setText("Title not found!");
		    
		    TextView tv3 = (TextView)findViewById(R.id.RegularTextView03);
		    if(!((((ConversationPostRead)post)).getConversation_text().isEmpty()))
		    	tv3.setText(clean((((ConversationPostRead)post)).getConversation_text()));
		    else
		    	tv3.setText("Body not found!");
		    
		    Button btn4 = (Button)findViewById(R.id.cancelarTextPostRead);
			 btn4.setOnClickListener(cancel);

	    }
	    else if(post.getType().equals("quote"))
	    {
	    	setContentView(R.layout.postread);
	    	TextView tv1 = (TextView)findViewById(R.id.RegularTextView01);
		    tv1.setText(((QuotePostRead)post).getDate());
		    
		    TextView tv2 = (TextView)findViewById(R.id.RegularTextView02);
		    if(!(((QuotePostRead)post)).getQuote_source().isEmpty())
		    	tv2.setText(clean((((QuotePostRead)post)).getQuote_source()));
		    else
		    	tv2.setText("Title not found!");
		    
		    TextView tv3 = (TextView)findViewById(R.id.RegularTextView03);
		    if(!((((QuotePostRead)post)).getQuote_text().isEmpty()))
		    	tv3.setText(clean((((QuotePostRead)post)).getQuote_text()));
		    else
		    	tv3.setText("Body not found!");
		    
		    Button btn4 = (Button)findViewById(R.id.cancelarTextPostRead);
			 btn4.setOnClickListener(cancel);
	    }
	    else if(post.getType().equals("link"))
	    {
	    	setContentView(R.layout.viewlinkpost);
	    	TextView tv1 = (TextView)findViewById(R.id.RegularTextView01);
		    tv1.setText(((LinkPostRead)post).getDate());
		    
		    TextView tv2 = (TextView)findViewById(R.id.RegularTextView02);
		    if(!(((LinkPostRead)post)).getLink_text().isEmpty())
		    	tv2.setText(clean((((LinkPostRead)post)).getLink_text()));
		    else
		    	tv2.setText("Title not found!");
		    
		    
		    urlLinkShow=((LinkPostRead) post).getLink_url();
		    Button btn1 = (Button)findViewById(R.id.linkbutton);
		    btn1.setText(urlLinkShow);
		    btn1.getBackground().setAlpha(255);
		    btn1.setOnClickListener(linkbutton);
		    
		    
		    Button btn4 = (Button)findViewById(R.id.cancelLinkPostRead);
			btn4.setOnClickListener(cancel);

	    }
	    else if(post.getType().equals("audio"))
	    {
	    	setContentView(R.layout.viewaudiopage);
	    	TextView tv1 = (TextView)findViewById(R.id.AudioTextView01);
		    tv1.setText(((AudioPostRead)post).getDate());
		    
		    TextView tv2 = (TextView)findViewById(R.id.AudioTextView02);
		    if(!(((AudioPostRead)post)).getId3artist().isEmpty())
		    	tv2.setText(clean((((AudioPostRead)post)).getId3artist()));
		    else
		    	tv2.setText("Artist not found!");
		    
		    TextView tv3 = (TextView)findViewById(R.id.AudioTextView03);
		    if(!((((AudioPostRead)post)).getId3album().isEmpty()))
		    	tv3.setText(clean((((AudioPostRead)post)).getId3album()));
		    else
		    	tv3.setText("Album not found!");
		    
		    TextView tv4 = (TextView)findViewById(R.id.AudioTextView04);
		    if(!(((AudioPostRead)post)).getId3title().isEmpty())
		    	tv4.setText(clean((((AudioPostRead)post)).getId3title()));
		    else
		    	tv4.setText("Title not found!");		    
		
		    Button btn4 = (Button)findViewById(R.id.cancelarAudioPostRead);
			btn4.setOnClickListener(cancel);

	    }
	    else if(post.getType().equals("video"))
	    {
	 
	  		String vidUrl = ((VideoPostRead)post).getUrl_post(); 
	  				
	  		Context context = v.getContext();
	  		setContentView(R.layout.viewvideopost);
	  			 
	  		VideoView videoView = (VideoView) findViewById(R.id.videoView1);
	  		MediaController mediaController = new MediaController(context);
	  		mediaController.setAnchorView(videoView);
	  				// Set video link (mp4 format )
	  		Uri video = Uri.parse(vidUrl);
	  		videoView.setMediaController(mediaController);
	  		videoView.setVideoURI(video);
	  		videoView.start();
	  		
	    }

	}

	private OnClickListener cancel = new OnClickListener()
	{
	    public void onClick(View v)
	    {
	       initialize();
	    }
	};
	
	private OnClickListener linkbutton = new OnClickListener()
	{
	    public void onClick(View v)
	    {                        
	    	Intent browserIntent = new Intent("android.intent.action.VIEW", 
	    			Uri.parse(urlLinkShow)); 
	    	startActivity(browserIntent);
	    }
	};  
	
	private Drawable ImageOperations(Context ctx, String url, String saveFilename) {
		try {
			InputStream is = (InputStream) this.fetch(url);
			Drawable d = Drawable.createFromStream(is, "src");
			return d;
		} catch (MalformedURLException e) {
			e.printStackTrace();
			return null;
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}

	public Object fetch(String address) throws MalformedURLException,IOException {
		URL url = new URL(address);
		Object content = url.getContent();
		return content;
	}
}

