package tumblr.Android;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.animation.LayoutAnimationController;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class TumblrAndroid extends Activity {

	private static String email;
	private static String password;
	private static String Nome=null;
	private String photoDirectory="";
	private String audioDirectory="";
	private String videoDirectory="";
	private int flagUpload = 0;

    /** Called when the activity is first created. */

    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
    
        setContentView(R.layout.main);
    
        Button btn1 = (Button)findViewById(R.id.btnLoggin);
       // btn1.ononSetAlpha
        btn1.getBackground().setAlpha(255);
        btn1.setOnClickListener(btnLoggin);
    
    }
  
    public static void setLayoutAnimation2(ViewGroup panel, Context ctx) {

    	  LayoutAnimationController controller = AnimationUtils.loadLayoutAnimation(ctx, R.anim.slideup);

    	  panel.setLayoutAnimation(controller);

    	}
    
    //Codigo respeitante a main.xml
    //---create an anonymous class to act as a button click listener---
    private OnClickListener btnLoggin = new OnClickListener()
	{
	    public void onClick(View v)
	    {                        
	        EditText editE = (EditText)findViewById(R.id.editEmail);
	        EditText editP = (EditText)findViewById(R.id.editPass);
	       
	        String t_email = editE.getText().toString();
	        String t_password = editP.getText().toString();

	        Authentication aut = new Authentication(t_email, t_password);
	       
	        if(aut.validate()) {
	        	email=t_email;
	        	password=t_password;
	        	Nome=aut.nome;
	        	Toast.makeText(getBaseContext(), 
	  	                "Login efectuado com sucesso!", 
	  	                Toast.LENGTH_LONG).show();
	        	showMenu();
			}
	        else
	        {
	        	  Toast.makeText(getBaseContext(), 
	  	                "Email: "+t_email+"\n"+"Pass: "+t_password+"\nDados invalidos!", 
	  	                Toast.LENGTH_LONG).show();
	        }
	    }
	};  
    
	//Codigo respeitante a menu.xml
    void showMenu()
    {
  
    	setContentView(R.layout.menu);
    	Button btn2 = (Button)findViewById(R.id.buttonPost);
    	
      	/*
      	Animation slideUpIn = AnimationUtils.loadAnimation(this, R.anim.slideup);
      	 
    	btn2.startAnimation(slideUpIn);
*/
    	
        btn2.setOnClickListener(buttonPost);
        
        Button btn3 = (Button)findViewById(R.id.dashBoard); 
        btn3.setOnClickListener(dashBoard);
        
    }
    
    private OnClickListener buttonPost = new OnClickListener()
	{
	    public void onClick(View v)
	    {                        
	       showMenuPosts();
	    }
	};
	
	private OnClickListener dashBoard = new OnClickListener()
	{
	    public void onClick(View v)
	    {                        
	    	Bundle bundle = new Bundle();
	    	bundle.putString("nome", Nome);	
	       Intent intent = new Intent(getApplicationContext(), ShowDashBoard.class);
	       intent.putExtras(bundle);
	       startActivityForResult(intent,0);
	    }
	};
    
	
	
    //Codigo respeitante a menuposts.xml
    void showMenuPosts() 
    {
    	setContentView(R.layout.menuposts);

        
        Animation slideUpIn = AnimationUtils.loadAnimation(this, R.anim.slideup);
        Animation slideUpIn2 = AnimationUtils.loadAnimation(this, R.anim.slideup2);
        Animation slideUpIn3 = AnimationUtils.loadAnimation(this, R.anim.slideup3);
        Animation slideUpIn4 = AnimationUtils.loadAnimation(this, R.anim.slideup4);
        Animation slideUpIn5 = AnimationUtils.loadAnimation(this, R.anim.slideup5);
        Animation slideUpIn6 = AnimationUtils.loadAnimation(this, R.anim.slideup6);
        Animation slideUpIn7 = AnimationUtils.loadAnimation(this, R.anim.slideup7);
        Animation slideUpIn8 = AnimationUtils.loadAnimation(this, R.anim.slideup8);
        Animation slidedown1 = AnimationUtils.loadAnimation(this, R.anim.slidedown);
        Button btn1 = (Button)findViewById(R.id.ButtonMenuPost);
        
    	Button btn2 = (Button)findViewById(R.id.buttonTextPost);
        btn2.setOnClickListener(buttonTextPost); 
    	
        Button btn3 = (Button)findViewById(R.id.buttonPhotoPost);
        btn3.setOnClickListener(buttonPhotoPost);   	
    	
        Button btn4 = (Button)findViewById(R.id.buttonQuotePost);
        btn4.setOnClickListener(buttonQuotePost);
        
        Button btn5 = (Button)findViewById(R.id.buttonLinkPost);
        btn5.setOnClickListener(buttonLinkPost);
        
        Button btn6 = (Button)findViewById(R.id.buttonChatPost);
        btn6.setOnClickListener(buttonChatPost);   	
    	
        Button btn7 = (Button)findViewById(R.id.buttonAudioPost);
        btn7.setOnClickListener(buttonAudioPost);
        
        Button btn8 = (Button)findViewById(R.id.buttonVideoPost);
        btn8.setOnClickListener(buttonVideoPost);
    	
        Button btn9 = (Button)findViewById(R.id.dashBoardMenuPosts); 
        btn9.setOnClickListener(dashBoard);
        
        btn1.startAnimation(slidedown1);
    	btn2.startAnimation(slideUpIn);
	    btn3.startAnimation(slideUpIn2);
	    btn4.startAnimation(slideUpIn3);
	    btn5.startAnimation(slideUpIn4);
	    btn6.startAnimation(slideUpIn5);
	    btn7.startAnimation(slideUpIn6);
	    btn8.startAnimation(slideUpIn7);
	    btn9.startAnimation(slideUpIn8);
	    

        
    }
    
    private OnClickListener buttonTextPost = new OnClickListener()
	{
	    public void onClick(View v)
	    {                        
	       showPostText();
	    }
	};
	
	private OnClickListener buttonLinkPost = new OnClickListener()
	{
		    public void onClick(View v)
		    {                        
		       showPostLink();
		    }
	};
	
	private OnClickListener buttonVideoPost= new OnClickListener()
	{
	    public void onClick(View v)
	    {                        
	       showPostVideo();
	    }
	};
		
	private OnClickListener buttonChatPost = new OnClickListener()
	{
		public void onClick(View v)
		{                        
			showPostChat();
		}
	};
	
	private OnClickListener buttonAudioPost = new OnClickListener()
	{
		public void onClick(View v)
		{                        
			showPostAudio();
		}
	};
	
	private OnClickListener buttonPhotoPost = new OnClickListener()
	{
	    public void onClick(View v)
	    {                        
	       showPhotoPost();
	    }
	};
	
	private OnClickListener buttonQuotePost = new OnClickListener()
	{
	    public void onClick(View v)
	    {                        
	       showQuotePost();
	    }
	};
    
	public void showPostVideo()
	{
		if(!videoDirectory.equals(""))
		{
			EditText c =(EditText)findViewById(R.id.editURLVideoPost);
			c.setText(videoDirectory, TextView.BufferType.EDITABLE);
		}
		flagUpload=3;
		setContentView(R.layout.videopost);
		
    	Button btn2 = (Button)findViewById(R.id.createVideoPost);
        btn2.setOnClickListener(createVideoPost);
        
        Button btn3 = (Button)findViewById(R.id.cancelVideoPost);
        btn3.setOnClickListener(cancelarPost);
        
        Button btn4 = (Button)findViewById(R.id.loadVideoFromMemory);
	    btn4.setOnClickListener(searchFiles);
	}
	
	public void showPostAudio()
	{
		flagUpload=2;
		setContentView(R.layout.audiopost);
		
    	Button btn2 = (Button)findViewById(R.id.createAudioPost);
        btn2.setOnClickListener(createAudioPost);
       
        Button btn3 = (Button)findViewById(R.id.cancelAudioPost);
        btn3.setOnClickListener(cancelarPost);
        
        
        Button btn4 = (Button)findViewById(R.id.loadAudioFromMemory);
	    btn4.setOnClickListener(searchFiles);
	}
	
	public void showPostChat()
	{
		setContentView(R.layout.chatpost);
    	Button btn2 = (Button)findViewById(R.id.createPost);
        btn2.setOnClickListener(createChatPost);
        Button btn3 = (Button)findViewById(R.id.cancelarChatPost);
        btn3.setOnClickListener(cancelarPost);
	}
    
	public void showPostLink() 
	{
		setContentView(R.layout.linkpost);
    	Button btn2 = (Button)findViewById(R.id.createLinkPost);
        btn2.setOnClickListener(createLinkPost);
        Button btn3 = (Button)findViewById(R.id.cancelarLinkPost);
        btn3.setOnClickListener(cancelarPost);
	}
	
    void showPostText()
    {
    	setContentView(R.layout.textpost);
    	Button btn2 = (Button)findViewById(R.id.createPost);
        btn2.setOnClickListener(createPost);
        Button btn3 = (Button)findViewById(R.id.cancelarTextPost);
        btn3.setOnClickListener(cancelarPost);
    }
    
	
	private OnClickListener createPost = new OnClickListener()
	{
	    public void onClick(View v)
	    {                 
	       EditText editTitlePost = (EditText)findViewById(R.id.editTitlePost);
	       EditText editTextPost = (EditText)findViewById(R.id.editText1Post);
	       String titlePost = editTitlePost.getText().toString();
	       String textPost = editTextPost.getText().toString();
	       
	       RegularPost reg = new RegularPost(email, password,titlePost,textPost );
	       reg.writeData();
	       
	       showMenuPosts();
	    }
	};
	
	private OnClickListener createAudioPost  = new OnClickListener()
	{
		public void onClick(View v)
	    {  
			EditText editUrlPost = (EditText)findViewById(R.id.editURLAudioPost);
			EditText editDescriptionPost = (EditText)findViewById(R.id.editDescriptionAudioPost);
			String urlPost = editUrlPost.getText().toString();
			String descriptionPost = editDescriptionPost.getText().toString();

			if(audioDirectory.equals("")){
				AudioPost aud = new AudioPost(email, password, urlPost, "", descriptionPost);
				aud.writeData();
		    }
		    else
		    {
		    	AudioPost aud = new AudioPost(email, password, urlPost, audioDirectory, descriptionPost);
		    	aud.uploadData(); 
		    	   
		    }
			
			audioDirectory="";
			showMenuPosts();
	    }
	};
	
	private OnClickListener createVideoPost  = new OnClickListener()
	{
	    public void onClick(View v)
	    {                 
	    	EditText editUrlPost = (EditText)findViewById(R.id.editURLVideoPost);
			EditText editDescriptionPost = (EditText)findViewById(R.id.editDescriptionVideoPost);
			String urlPost = editUrlPost.getText().toString();
			String descriptionPost = editDescriptionPost.getText().toString();

			 if(videoDirectory.equals("")){
				 VideoPost vid = new VideoPost(email,password, urlPost,"","",descriptionPost);
			       vid.writeData();
			 }
			 else
			 {
				 VideoPost vid = new VideoPost(email,password, urlPost,videoDirectory,"",descriptionPost);
				 vid.uploadData(); 
			 }
			 
			videoDirectory="";
			showMenuPosts();
	    }
	};
	
	private OnClickListener createChatPost = new OnClickListener()
	{
	    public void onClick(View v)
	    {                 
	    	EditText editTitlePost = (EditText)findViewById(R.id.editTitlePost);
			EditText editDialogPost = (EditText)findViewById(R.id.editText1Post);
			String titlePost = editTitlePost.getText().toString();
			String dialogPost = editDialogPost.getText().toString();
	
			ConversationPost conv = new ConversationPost(email, password, titlePost, dialogPost);
			conv.writeData();
			
			showMenuPosts();
	    }
	};
	
	private OnClickListener createLinkPost = new OnClickListener()
	{
	    public void onClick(View v)
	    {                 
	    	EditText editTitleLinkPost = (EditText)findViewById(R.id.editTitleLinkPost);
			EditText editUrlLinkPost = (EditText)findViewById(R.id.editUrlLinkPost);
			EditText editDescLinkPost = (EditText)findViewById(R.id.editDescLinkPost);
			String titlePost = editTitleLinkPost.getText().toString();
			String urlPost = editUrlLinkPost.getText().toString();
			String descriptionPost = editDescLinkPost.getText().toString();
	
			LinkPost lin = new LinkPost(email, password, urlPost, titlePost, descriptionPost);
			lin.writeData();
			
			showMenuPosts();
	    }
	};
	

	
	//PHOTO
	void showPhotoPost()
	{
		flagUpload=1;
		if(!photoDirectory.equals(""))
		{
			EditText c =(EditText)findViewById(R.id.editURLPhotoPost);
			c.setText(photoDirectory);
		}
	    setContentView(R.layout.photopost);
	    Button btn2 = (Button)findViewById(R.id.createPhotoPost);
	    btn2.setOnClickListener(createPhotoPost);
	        
	    Button btn3 = (Button)findViewById(R.id.loadPhotoFromMemory);
	    btn3.setOnClickListener(searchFiles);
	    
	    Button btn4 = (Button)findViewById(R.id.cancelPhotoPost);//
        btn4.setOnClickListener(cancelarPost);
        
	}
	
	private OnClickListener searchFiles = new OnClickListener()
	{
	    public void onClick(View v)
	    {                 
	       Intent intent = new Intent(getApplicationContext(), SearchFiles.class);
           startActivityForResult(intent,0);     
	    }
	};
	

	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		  // TODO Auto-generated method stub
		  super.onActivityResult(requestCode, resultCode, data);
		   if (requestCode==0)
		   {
		    switch (resultCode)
		    { case RESULT_OK:
		    	if(flagUpload==1){
		    		photoDirectory=data.getStringExtra("path");
		    		showPhotoPost();
		    	}
		    	else if(flagUpload==2){
		    		audioDirectory=data.getStringExtra("path");
		    		showPostAudio();
		    	}
		    	else if(flagUpload==3){
		    		videoDirectory=data.getStringExtra("path");
		    		showPostVideo();
		    	}
		    	flagUpload=0;
		    	
		    	 
		    	//showPhotoPost();
		      break;
		     case RESULT_CANCELED:
		    	 
		      break;
		  
		    }
		  }
	}
	
	private OnClickListener createPhotoPost = new OnClickListener()
	{
	    public void onClick(View v)
	    {      
	    
	       EditText editURLPost = (EditText)findViewById(R.id.editURLPhotoPost);
	       EditText editDescriptionPost = (EditText)findViewById(R.id.editDescriptionPhotoPost);
	       String urlPost = editURLPost.getText().toString();
	       String descriptionPost = editDescriptionPost.getText().toString();
	       
	       if(photoDirectory.equals("")){
		       PhotoPost photo = new PhotoPost(email, password,urlPost,"",descriptionPost );
		       photo.writeData();
	       }
	       else
	       {
	    	   PhotoPost photo = new PhotoPost(email, password,urlPost,photoDirectory,descriptionPost );
	    	   photo.uploadData(); 
	    	   photoDirectory="";
	       }
	       
	       showMenuPosts();
	    }
	};
	
	//QUOTE
	void showQuotePost()
	{
	    	setContentView(R.layout.quotepost);
	    	Button btn2 = (Button)findViewById(R.id.createQuotePost);
	        btn2.setOnClickListener(createQuotePost);
	        
	        Button btn3 = (Button)findViewById(R.id.cancelQuotePost);
	        btn3.setOnClickListener(cancelarPost);
	}
	
	
	private OnClickListener createQuotePost = new OnClickListener()
	{
	    public void onClick(View v)
	    {                 
	       EditText editQuotePost = (EditText)findViewById(R.id.editQuoteQuotePost);
	       EditText editSourtePost = (EditText)findViewById(R.id.editSourceQuotePost);
	       String quotePost = editQuotePost.getText().toString();
	       String sourcePost = editSourtePost.getText().toString();
	       
	       QuotePost quote = new QuotePost(email, password,quotePost,sourcePost );
	       quote.writeData();
	       
	       showMenuPosts();
	    }
	};
	
	private OnClickListener cancelarPost = new OnClickListener()
	{
	    public void onClick(View v)
	    {
	       showMenuPosts();
	    }
	};
}